/*
 * generated by Xtext 2.12.0
 */
package components.serializer;

import com.google.inject.Inject;
import components.Attribute;
import components.Component;
import components.ComponentsPackage;
import components.Composition;
import components.Method;
import components.Model;
import components.ProvidedInterface;
import components.RequiredInterface;
import components.services.DslGrammarAccess;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;

@SuppressWarnings("all")
public class DslSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private DslGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == ComponentsPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case ComponentsPackage.ATTRIBUTE:
				sequence_Attribute(context, (Attribute) semanticObject); 
				return; 
			case ComponentsPackage.COMPONENT:
				sequence_Component(context, (Component) semanticObject); 
				return; 
			case ComponentsPackage.COMPOSITION:
				sequence_Composition(context, (Composition) semanticObject); 
				return; 
			case ComponentsPackage.METHOD:
				sequence_Method(context, (Method) semanticObject); 
				return; 
			case ComponentsPackage.MODEL:
				sequence_Model(context, (Model) semanticObject); 
				return; 
			case ComponentsPackage.PARAMETER:
				sequence_Parameter(context, (components.Parameter) semanticObject); 
				return; 
			case ComponentsPackage.PROVIDED_INTERFACE:
				sequence_ProvidedInterface(context, (ProvidedInterface) semanticObject); 
				return; 
			case ComponentsPackage.REQUIRED_INTERFACE:
				sequence_RequiredInterface(context, (RequiredInterface) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     Attribute returns Attribute
	 *
	 * Constraint:
	 *     (name=ID type=EString)
	 */
	protected void sequence_Attribute(ISerializationContext context, Attribute semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ComponentsPackage.Literals.NAMED_ELEMENT__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ComponentsPackage.Literals.NAMED_ELEMENT__NAME));
			if (transientValues.isValueTransient(semanticObject, ComponentsPackage.Literals.TYPED_ELEMENT__TYPE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ComponentsPackage.Literals.TYPED_ELEMENT__TYPE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getAttributeAccess().getNameIDTerminalRuleCall_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getAttributeAccess().getTypeEStringParserRuleCall_2_0(), semanticObject.getType());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Component returns Component
	 *
	 * Constraint:
	 *     (name=ID (attributes+=Attribute | required+=RequiredInterface | provided+=ProvidedInterface)*)
	 */
	protected void sequence_Component(ISerializationContext context, Component semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Composition returns Composition
	 *
	 * Constraint:
	 *     (out=[ProvidedInterface|QualifiedName] in=[RequiredInterface|QualifiedName])
	 */
	protected void sequence_Composition(ISerializationContext context, Composition semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ComponentsPackage.Literals.COMPOSITION__OUT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ComponentsPackage.Literals.COMPOSITION__OUT));
			if (transientValues.isValueTransient(semanticObject, ComponentsPackage.Literals.COMPOSITION__IN) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ComponentsPackage.Literals.COMPOSITION__IN));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getCompositionAccess().getOutProvidedInterfaceQualifiedNameParserRuleCall_0_0_1(), semanticObject.eGet(ComponentsPackage.Literals.COMPOSITION__OUT, false));
		feeder.accept(grammarAccess.getCompositionAccess().getInRequiredInterfaceQualifiedNameParserRuleCall_2_0_1(), semanticObject.eGet(ComponentsPackage.Literals.COMPOSITION__IN, false));
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Method returns Method
	 *
	 * Constraint:
	 *     (name=ID (parameters+=Parameter parameters+=Parameter*)? type=EString)
	 */
	protected void sequence_Method(ISerializationContext context, Method semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Model returns Model
	 *
	 * Constraint:
	 *     (components+=Component* compositions+=Composition*)
	 */
	protected void sequence_Model(ISerializationContext context, Model semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Parameter returns Parameter
	 *
	 * Constraint:
	 *     (name=ID type=EString)
	 */
	protected void sequence_Parameter(ISerializationContext context, components.Parameter semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, ComponentsPackage.Literals.NAMED_ELEMENT__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ComponentsPackage.Literals.NAMED_ELEMENT__NAME));
			if (transientValues.isValueTransient(semanticObject, ComponentsPackage.Literals.TYPED_ELEMENT__TYPE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, ComponentsPackage.Literals.TYPED_ELEMENT__TYPE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getParameterAccess().getNameIDTerminalRuleCall_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getParameterAccess().getTypeEStringParserRuleCall_2_0(), semanticObject.getType());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     ProvidedInterface returns ProvidedInterface
	 *
	 * Constraint:
	 *     (name=ID methods+=Method*)
	 */
	protected void sequence_ProvidedInterface(ISerializationContext context, ProvidedInterface semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     RequiredInterface returns RequiredInterface
	 *
	 * Constraint:
	 *     (name=ID methods+=Method*)
	 */
	protected void sequence_RequiredInterface(ISerializationContext context, RequiredInterface semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
