/*
 * generated by Xtext 2.12.0
 */
package components.validation

import components.Composition
import org.eclipse.xtext.validation.Check
import components.Method
import components.Parameter
import components.ComponentsPackage

/**
 * This class contains custom validation rules. 
 *
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#validation
 */
class DslValidator extends AbstractDslValidator {
	
//	public static val INVALID_NAME = 'invalidName'
//
//	@Check
//	def checkGreetingStartsWithCapital(Greeting greeting) {
//		if (!Character.isUpperCase(greeting.name.charAt(0))) {
//			warning('Name should start with a capital', 
//					DslPackage.Literals.GREETING__NAME,
//					INVALID_NAME)
//		}
//	}
	
	@Check
	def checkBindings(Composition composition) {
		val r=composition.in;
		val p=composition.out;
		for (mr: r.methods) {
			var compatible=false;
			for (mp : p.methods) {
				 if (checkMethodCompatibility(mr,mp)) compatible=true;
			}
			if (!compatible) 
				error("Required method "+mr.name+" has no compatible provided method!",composition,ComponentsPackage.Literals.COMPOSITION__IN)
		}
	}
	
	def checkMethodCompatibility(Method m1, Method m2) {
		if (! m1.name.equals(m2.name)) return false;
		if (! m1.type.equals(m2.type)) return false;
		if (m1.parameters.size!=m2.parameters.size) return false;
		for (var i=0; i< m1.parameters.size; i++){
			if (! checkParameterCompatibility(m1.parameters.get(i),m2.parameters.get(i)))
				return false;
		}
		return true
	}
	
	def checkParameterCompatibility(Parameter p1, Parameter p2) {
		//if (! p1.name.equals(p2.name)) return false;
		return p1.type.equals(p2.type)
	}
	
}
