/**
 * generated by Xtext 2.12.0
 */
package components.formatting2;

import com.google.inject.Inject;
import components.Attribute;
import components.Component;
import components.Composition;
import components.Model;
import components.ProvidedInterface;
import components.RequiredInterface;
import components.services.DslGrammarAccess;
import java.util.Arrays;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.formatting2.AbstractFormatter2;
import org.eclipse.xtext.formatting2.IFormattableDocument;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.xbase.lib.Extension;

@SuppressWarnings("all")
public class DslFormatter extends AbstractFormatter2 {
  @Inject
  @Extension
  private DslGrammarAccess _dslGrammarAccess;
  
  protected void _format(final Model model, @Extension final IFormattableDocument document) {
    EList<Component> _components = model.getComponents();
    for (final Component component : _components) {
      document.<Component>format(component);
    }
    EList<Composition> _compositions = model.getCompositions();
    for (final Composition composition : _compositions) {
      document.<Composition>format(composition);
    }
  }
  
  protected void _format(final Component component, @Extension final IFormattableDocument document) {
    EList<Attribute> _attributes = component.getAttributes();
    for (final Attribute attribute : _attributes) {
      document.<Attribute>format(attribute);
    }
    EList<RequiredInterface> _required = component.getRequired();
    for (final RequiredInterface requiredInterface : _required) {
      document.<RequiredInterface>format(requiredInterface);
    }
    EList<ProvidedInterface> _provided = component.getProvided();
    for (final ProvidedInterface providedInterface : _provided) {
      document.<ProvidedInterface>format(providedInterface);
    }
  }
  
  public void format(final Object component, final IFormattableDocument document) {
    if (component instanceof XtextResource) {
      _format((XtextResource)component, document);
      return;
    } else if (component instanceof Component) {
      _format((Component)component, document);
      return;
    } else if (component instanceof Model) {
      _format((Model)component, document);
      return;
    } else if (component instanceof EObject) {
      _format((EObject)component, document);
      return;
    } else if (component == null) {
      _format((Void)null, document);
      return;
    } else if (component != null) {
      _format(component, document);
      return;
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(component, document).toString());
    }
  }
}
