/**
 * generated by Xtext 2.12.0
 */
package components.validation;

import components.ComponentsPackage;
import components.Composition;
import components.Method;
import components.Parameter;
import components.ProvidedInterface;
import components.RequiredInterface;
import components.validation.AbstractDslValidator;
import org.eclipse.emf.common.util.EList;
import org.eclipse.xtext.validation.Check;

/**
 * This class contains custom validation rules.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#validation
 */
@SuppressWarnings("all")
public class DslValidator extends AbstractDslValidator {
  @Check
  public void checkBindings(final Composition composition) {
    final RequiredInterface r = composition.getIn();
    final ProvidedInterface p = composition.getOut();
    EList<Method> _methods = r.getMethods();
    for (final Method mr : _methods) {
      {
        boolean compatible = false;
        EList<Method> _methods_1 = p.getMethods();
        for (final Method mp : _methods_1) {
          boolean _checkMethodCompatibility = this.checkMethodCompatibility(mr, mp);
          if (_checkMethodCompatibility) {
            compatible = true;
          }
        }
        if ((!compatible)) {
          String _name = mr.getName();
          String _plus = ("Required method " + _name);
          String _plus_1 = (_plus + " has no compatible provided method!");
          this.error(_plus_1, composition, ComponentsPackage.Literals.COMPOSITION__IN);
        }
      }
    }
  }
  
  public boolean checkMethodCompatibility(final Method m1, final Method m2) {
    boolean _equals = m1.getName().equals(m2.getName());
    boolean _not = (!_equals);
    if (_not) {
      return false;
    }
    boolean _equals_1 = m1.getType().equals(m2.getType());
    boolean _not_1 = (!_equals_1);
    if (_not_1) {
      return false;
    }
    int _size = m1.getParameters().size();
    int _size_1 = m2.getParameters().size();
    boolean _notEquals = (_size != _size_1);
    if (_notEquals) {
      return false;
    }
    for (int i = 0; (i < m1.getParameters().size()); i++) {
      boolean _checkParameterCompatibility = this.checkParameterCompatibility(m1.getParameters().get(i), m2.getParameters().get(i));
      boolean _not_2 = (!_checkParameterCompatibility);
      if (_not_2) {
        return false;
      }
    }
    return true;
  }
  
  public boolean checkParameterCompatibility(final Parameter p1, final Parameter p2) {
    return p1.getType().equals(p2.getType());
  }
}
